//---------------------------------------------------------
// barrera-una.cc: barrera que sólo funciona una vez
//---------------------------------------------------------

#include <unistd.h>  // alarm
#include <atomic>
#include <iostream>  // cout endl
#include <mutex>     // mutex
#include <string>    // string
#include <thread>    // thread

//---------------------------------------------------------

const int N = 8;

//---------------------------------------------------------

class barrera_t
{
public:
	barrera_t(unsigned _limite): contador(0), limite(_limite) {}

	void esperar()
	{
		++contador;
		while (contador < limite);
	}

private:
	std::atomic<int> contador;
	int limite;
} barrera(N);

//---------------------------------------------------------

void hebra(int yo)
{
	std::string   antes = std::to_string(yo) +   ": antes\n", 
	            despues = std::to_string(yo) + ": después\n";
	while(true)
	{
		std::cout << antes << std::flush;
		barrera.esperar();
		std::cout << despues << std::flush;
	}
}

//---------------------------------------------------------

int main()
{
	ualarm(150000, 0); // 150ms
	std::thread t[N];
	for (int i = 0; i < N; ++i) t[i] = std::thread(hebra, i);
	for (auto& i: t) i.join();
}

//---------------------------------------------------------

