//---------------------------------------------------------
// spinlock-y.cc
//---------------------------------------------------------

#include <unistd.h>  // alarm
#include <atomic>    // atomic
#include <iostream>  // cout endl
#include <mutex>     // mutex
#include <string>    // string
#include <thread>    // thread

//---------------------------------------------------------

const int N = 8;

//---------------------------------------------------------

class barrera_t
{
public:
	explicit barrera_t(unsigned _limit): 
		count(_limit), generation(0), limit(_limit) {}

	void esperar()
	{
		unsigned gen = generation;
		
		if (--count != 0)
		{
//			while ((gen == generation) && (count != 0))
			while (gen == generation)
				std::this_thread::yield();
		}
		else
		{
			if (generation.compare_exchange_weak(gen, gen + 1))
				count = limit;
		}
	}

private:
	std::atomic<unsigned> count, generation;
	unsigned limit;
} barrera(N);

//---------------------------------------------------------

void hebra(int yo)
{
	std::string   antes = std::to_string(yo) +   ": antes\n", 
	            despues = std::to_string(yo) + ": después\n";
	while(true)
	{
		std::cout << antes << std::flush;
		barrera.esperar();
		std::cout << despues << std::flush;
	}
}

//---------------------------------------------------------

int main()
{
	ualarm(150000, 0); // 150ms
	std::thread t[N];
	for (int i = 0; i < N; ++i) t[i] = std::thread(hebra, i);
	for (auto& i: t) i.join();
}

//---------------------------------------------------------

